;
; echo.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; echo [files]
;;
;;   Prints arguments and filenames. Useful for testing wildcard expansion.
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= true
first		= $2

banner		= "echo 0.2 by soci/singular"

		.include "lib.asm"

		.section code
start2		.proc
		ldx #<arglist
		ldy #>arglist
		jsr parseargs
		lda #<arglist
		sta p1
		lda #>arglist
		sta p1+1

		lda #1
		sta first

		ldx #STDOUT_LFN
		jsr kernal.chkout
		bcs err

loop		ldy #0
		lda (p1),y
		beq _exit
		tax
		lsr first
		bcs +
		lda #" "
		jsr kernal.chrout
+
-		iny
		lda (p1),y
		jsr kernal.chrout
		dex
		bne -
                jsr termstring
		jmp loop

_exit		lda #"{cr}"
		jsr kernal.chrout
		jsr kernal.clrchn
err		jmp exit
		.pend
		.send code
