;
; ln.asm
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;; ln [path] [link name]
;;
;;   Creates a link
;;
;    This file is part of the IDE64 shell utilities.
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;

WILDEXP		= false

OUTPUT_LFN	= 1

banner		= "ln 0.2 by soci/singular"

		.include "lib.asm"

		.section code
start2		.proc
		ldx #<arglist
		ldy #>arglist
		jsr parseargs

		lda arglist
		beq _end
		sec
		adc #<arglist
		sta p1
		lda #0
		tay
		adc #>arglist
		sta p1+1

		lda (p1),y
		beq _end
		sta kernal.filename_len
-		iny
		lda (p1),y
		sta fname-1,y
		cpy kernal.filename_len
		blt -
		ldx #3
-		lda lnk,x
		iny
		sta fname-1,y
		dex
		bpl -
		tya
		ldx #<fname
		ldy #>fname
		jsr kernal.setnam
		lda #OUTPUT_LFN
		ldx mydrive
		tay
		jsr kernal.setlfs
		jsr kernal.open
		bcs _end

		ldx #OUTPUT_LFN
		jsr kernal.chkout
		bcs _err
		ldy #0
-		lda arglist+1,y
		jsr kernal.chrout
		iny
		cpy arglist
		blt -
		jsr kernal.clrchn
_err		lda #OUTPUT_LFN
		jsr kernal.close

_end		jmp exit

		.section data
lnk		.text "knl,"
		.send

		.section bss
fname		.fill 256
		.send bss
		.pend
		.send code

